<?php
/**
	Plugin Name: arianpal for EDD
	Version: 1.7
	Description: این افزونه درگاه <a href="https://www.arianpal.com/" target="_blank">آرین پال</a> را به افزونه Easy Digital Downloads اضافه می&zwnj;کند. این افزونه با نسخه 1.7.1  سازگار است.


	Author: arianpal
	Author URI: http://arianpal.com
**/
@session_start();
 if(!class_exists('nusoap_client'))
     include_once(WP_PLUGIN_DIR.'/edd-arianpal/nu/nusoap.php');
 function eddp_rial ($formatted, $currency, $price) {
	return $price . ' ریال';
}
add_filter( 'eddp_rial_currency_filter_after', 'eddp_rial', 10, 3 );

function pp_add_gateway ($gateways) {
	$gateways['arianpal'] = array('admin_label' => 'آرین&zwnj;پال', 'checkout_label' => 'پرداخت آنلاين آرین&zwnj;پال');
	return $gateways;
}
add_filter( 'edd_payment_gateways', 'pp_add_gateway' );

function pp_cc_form () {
	do_action( 'pp_cc_form_action' );
}
add_filter( 'edd_arianpal_cc_form', 'pp_cc_form' );

function pp_process_payment ($purchase_data) {
	global $edd_options;

	$payment_data = array(
		'price' => $purchase_data['price'],
		'date' => $purchase_data['date'],
		'user_email' => $purchase_data['post_data']['edd_email'],
		'purchase_key' => $purchase_data['purchase_key'],
        'arianpal-ref' => '',
		'currency' => $edd_options['currency'],
		'downloads' => $purchase_data['downloads'],
		'cart_details' => $purchase_data['cart_details'],
		'user_info' => $purchase_data['user_info'],
		'status' => 'pending'
	);
	$payment = edd_insert_payment($payment_data);

	if ($payment) {

		$_SESSION['arianpal_payment'] = $payment;
		$return = urlencode(add_query_arg('order', 'arianpal', get_permalink($edd_options['success_page'])));
        //echo '<pre>';var_dump($edd_options);exit;

        $client = new nusoap_client('http://merchant.arianpal.com/WebService.asmx?wsdl', 'wsdl');

        $price = $purchase_data['price'];

        if($edd_options['currency'] == 'RIAL')
              $price = $price / 10;

        $listener_url = trailingslashit( home_url() ).'?edd-listener=IPN2';

        $parameters = array("MerchantID" =>  $edd_options['arianpal_Merchant']
        , "Password" => $edd_options['arianpal_Password']
        , "Price" =>$price
        , "ReturnPath" =>  $listener_url
        , "ResNumber" =>$payment
        , "Description" => 'پرداخت سفارش '.$payment
        , "Paymenter" =>$purchase_data['post_data']['edd_first'].' '.$purchase_data['post_data']['edd_last']
        , "Email" => $purchase_data['post_data']['edd_email']
        , "Mobile" => '');

		$desc='پرداخت سفارش شاره'.$payment ;
       	$res = $client->call('RequestPayment', array($parameters));
        $price = $payment_data['price']  ;
		$_SESSION['ppal_price'] = $payment_data['price'];
        $_SESSION['ppal_date'] = $payment_data['date'];
		$_SESSION['ppal_user_email'] =$purchase_data['post_data']['edd_email'] ;
		$_SESSION['ppal_purchase_key'] = $payment_data['purchase_key'];
       	$_SESSION['ppal_currency'] = $payment_data['currency'];
		$_SESSION['ppal_downloads'] = $payment_data['downloads'];
		$_SESSION['ppal_cart_details'] = $payment_data['cart_details'];
		$_SESSION['ppal_user_info'] = $payment_data['user_info'];

        $PayPath = $res['RequestPaymentResult']['PaymentPath'];
        $Status = $res['RequestPaymentResult']['ResultStatus'];

        if ($Status == 'Succeed')
        {
            echo "<html><meta http-equiv='Content-Type' content='text/html; charset=utf-8' /> <head><title>Connecting ....</title><head><body onload=\"javascript:window.location='$PayPath'\" style=\"font-family:tahoma; text-align:center;font-waight:bold;direction:rtl\">در حال اتصال به درگاه پرداخت آرین پال ...</body></html>";
            exit;
        }
        else
        {
    	   wp_die('در اتصال به درگاه خطايي رخ داده است ! <br> کد خطا : '. $Status );
    	}
   	}
    else
      {
  		edd_send_back_to_checkout('?payment-mode=' . $purchase_data['post_data']['edd-gateway']);
      }
}
add_action('edd_gateway_arianpal', 'pp_process_payment');

function pp_verify() {
	global $edd_options;
    $resp='-';

    if( isset( $_GET['edd-listener'] ) && $_GET['edd-listener'] == 'IPN2' && isset($_POST['status']) )
     {
        // = $_SESSION['arianpal_payment'];
       	if( $_POST['status'] == 100){

        $Refnumber = $_POST['refnumber'];
        $Resnumber = $_POST['resnumber'];
        $resp = $Refnumber;
        $payment = $Resnumber;
        $MerchantID = $edd_options['arianpal_Merchant'];
        $Password = $edd_options['arianpal_Password'];
        $amount = $_SESSION['ppal_price'];

         if($edd_options['currency'] == 'RIAL')
              $amount = $amount / 10;

        $parameters = array("MerchantID" => $MerchantID ,
                      "Password" =>$Password , "Price" =>$amount,"RefNum" =>$Refnumber );

        $client = new nusoap_client('http://merchant.arianpal.com/WebService.asmx?wsdl', 'wsdl');

        $result = $client->call('verifyPayment', $parameters);

        $Status = $result['verifyPaymentResult']['ResultStatus'];
        $PayPrice = $result['verifyPaymentResult']['PayementedPrice'];


		edd_empty_cart();

       if($Status == 'Success')// Your Peyment Code Only This Event
        {
            update_post_meta( $payment, '_edd_payment_ppalrefnum',$Refnumber);

            edd_insert_payment_note( $payment, sprintf( __( 'شماره رسيد پرداخت : %s', 'edd' ) , $Refnumber ) );
			edd_update_payment_status($payment, 'publish');
			edd_send_to_success_page();

		}
       else
        {
			edd_update_payment_status($payment, 'failed');
			$failed_page = get_permalink($edd_options['failure_page']);
			wp_redirect( $failed_page );
			exit;
		}
	}
    else
    {
            edd_update_payment_status($payment, 'failed');
            update_post_meta( $payment, '_edd_payment_ppalrefnum','-');

			$failed_page = get_permalink($edd_options['failure_page']);
			wp_redirect( $failed_page );
			exit;
    }
  }
}
add_action('init', 'pp_verify');

function pp_add_settings ($settings) {
	$arianpal_settings = array (
		array (
			'id'		=>	'arianpal_Setting',
            'name'		=>	'<strong>پيکربندي آرین&zwnj;پال</strong>',
			'desc'		=>	'پيکربندي آرین&zwnj;پال با تنظیمات فروشگاه',
			'type'		=>	'header'
		),
		array (
			'id'		=>	'arianpal_Merchant',
            'name'      => 'شناسه درگاه - Merchant' ,
            'desc'		=>	'',
			'type'		=>	'text',
			'size'		=>	'regular'
		) ,
        	array (
			'id'		=>	'arianpal_Password',
            'name'      => 'کلمه عبور - Password' ,
            'desc'		=>	'',
			'type'		=>	'text',
			'size'		=>	'regular'
		)

      //
	);
	return array_merge( $settings, $arianpal_settings );
}
add_filter('edd_settings_gateways', 'pp_add_settings');
?>